package cn.gygxzc.cloud.tina.fdfs;

import io.reactivex.Observable;
import io.reactivex.Single;
import io.reactivex.SingleEmitter;
import io.reactivex.SingleOnSubscribe;
import io.reactivex.schedulers.Schedulers;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by niantuo on 2018/10/27.
 * 这种方式的确是可以使用的，但是不知道在实际过程中会不会表现很糟糕
 */

public class RxJavaTest {

    public static void main(String[] args) {
        List<Integer> integers = new ArrayList<>();
        final Object mLock = new Object();
        integers.add(1000);
        integers.add(2000);
        integers.add(2500);
        integers.add(500);
        integers.add(1500);
        long startTime = System.currentTimeMillis();
        Observable.fromIterable(integers)
                .flatMapSingle(RxJavaTest::task)
                .doOnNext(threadId->{
                    System.out.printf("onNex: %d,threadId:%d \n",System.currentTimeMillis(),threadId);
                })
                .toList()
                .subscribe(list->{
                    System.out.printf("complete time: %d \n",System.currentTimeMillis());
                    synchronized (mLock){
                        mLock.notifyAll();
                    }
                });
        synchronized (mLock){
            try {
                mLock.wait();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        System.out.printf("main thread:%d  耗时：%d  \n",System.currentTimeMillis(),System.currentTimeMillis()-startTime);
    }

    private static Single<Long> task(long sleep){
        return Single.create((SingleOnSubscribe<Long>) emitter -> {
            System.out.printf("current thread: %d,start Time: %d \n",Thread.currentThread().getId(),System.currentTimeMillis());
            Thread.sleep(sleep);
            emitter.onSuccess(Thread.currentThread().getId());
            System.out.printf("current thread: %d,end Time: %d \n",Thread.currentThread().getId(),System.currentTimeMillis());
        }).subscribeOn(Schedulers.io())
                .retry(3);
    }

}
