package cn.gygxzc.envir.sys.service

import cn.gygxzc.envir.sys.model.CommonFile
import org.springframework.cloud.openfeign.FeignClient
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RequestMethod

/**
 * Created by niantuo on 2018/12/20.
 * 获取文件的信息服务
 */
@FeignClient("gateway")
interface IFileInfoService {

    /**
     * 根据文件的id获取文件的详细信息
     *
     * @param ids 文件的id
     * @return 文件的详细信息
     */
    @RequestMapping(value = ["/info"], method = [RequestMethod.POST])
    fun queryByIds(@RequestBody ids: List<Long>): List<CommonFile>

    /**
     * 根据文件的id获取文件的简单信息
     *
     * @param ids 文件的id
     * @return 文件的简略信息
     */
    @RequestMapping(value = ["/info/simp"], method = [RequestMethod.POST])
    fun querySimpByIds(@RequestBody ids: List<Long>): List<CommonFile>
}